﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Sample_2013
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        internal string xamltext = System.IO.File.ReadAllText(@"C:\Users\narendran\Desktop\xamlText.xaml");
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new ViewModel();
            rte.TextChanged += rte_TextChanged;
        }

        void rte_TextChanged(object obj, Syncfusion.Windows.Tools.Controls.TextChangedEventArgs args)
        {
            //Updates the changes made in RichTextBoxAdv to ViewModel.
            //XamlText property of RichTextBoxAdv, is updated only on accessing this property. Hence it gets the Xaml based on current content and update to ViewModel.
            (this.DataContext as ViewModel).XamlContentInternal = rte.XAMLText;
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(xamltext))
                //Imports the xaml text to RichTextBoxAdv.
                (DataContext as ViewModel).XamlContent = xamltext;
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            // Sets XamlContent to xamltext. 
            xamltext = (DataContext as ViewModel).XamlContent;
        }
    }
    public class ViewModel : INotifyPropertyChanged
    {
        private string xamlContent;
        public ViewModel()
        {
        }

        public string XamlContent
        {
            get
            {
                return xamlContent;
            }
            set
            {
                xamlContent = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("XamlContent"));
            }
        }

        internal string XamlContentInternal
        {
            get
            {
                return xamlContent;
            }
            set
            {
                xamlContent = value;
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
